/*
 *     This file is part of the Squashtest platform.
 *     Copyright (C) Henix, henix.fr
 *
 *     See the NOTICE file distributed with this work for additional
 *     information regarding copyright ownership.
 *
 *     This is free software: you can redistribute it and/or modify
 *     it under the terms of the GNU Lesser General Public License as published by
 *     the Free Software Foundation, either version 3 of the License, or
 *     (at your option) any later version.
 *
 *     this software is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU Lesser General Public License for more details.
 *
 *     You should have received a copy of the GNU Lesser General Public License
 *     along with this software.  If not, see <http://www.gnu.org/licenses/>.
 */
package org.squashtest.tm.service.internal.display.grid.search;

import static org.squashtest.tm.jooq.domain.Tables.AUTOMATED_TEST;
import static org.squashtest.tm.jooq.domain.Tables.AUTOMATED_TEST_TECHNOLOGY;
import static org.squashtest.tm.jooq.domain.Tables.AUTOMATION_REQUEST;
import static org.squashtest.tm.jooq.domain.Tables.CALL_TEST_STEP;
import static org.squashtest.tm.jooq.domain.Tables.EXPLORATORY_TEST_CASE;
import static org.squashtest.tm.jooq.domain.Tables.HIGH_LEVEL_REQUIREMENT;
import static org.squashtest.tm.jooq.domain.Tables.KEYWORD_TEST_CASE;
import static org.squashtest.tm.jooq.domain.Tables.MILESTONE;
import static org.squashtest.tm.jooq.domain.Tables.MILESTONE_REQ_VERSION;
import static org.squashtest.tm.jooq.domain.Tables.PROJECT;
import static org.squashtest.tm.jooq.domain.Tables.REQUIREMENT;
import static org.squashtest.tm.jooq.domain.Tables.REQUIREMENT_LIBRARY_NODE;
import static org.squashtest.tm.jooq.domain.Tables.REQUIREMENT_VERSION;
import static org.squashtest.tm.jooq.domain.Tables.REQUIREMENT_VERSION_COVERAGE;
import static org.squashtest.tm.jooq.domain.Tables.RESOURCE;
import static org.squashtest.tm.jooq.domain.Tables.SCRIPTED_TEST_CASE;
import static org.squashtest.tm.jooq.domain.Tables.TEST_CASE;
import static org.squashtest.tm.jooq.domain.Tables.TEST_CASE_LIBRARY_NODE;
import static org.squashtest.tm.jooq.domain.Tables.TEST_CASE_STEPS;

import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import org.jooq.Condition;
import org.jooq.DSLContext;
import org.jooq.Field;
import org.jooq.SelectSeekStepN;
import org.jooq.SortField;
import org.jooq.Table;
import org.jooq.impl.DSL;
import org.squashtest.tm.domain.EntityType;
import org.squashtest.tm.service.internal.display.grid.AbstractGrid;
import org.squashtest.tm.service.internal.display.grid.GridRequest;
import org.squashtest.tm.service.internal.display.grid.GridSort;
import org.squashtest.tm.service.internal.display.grid.columns.GridColumn;
import org.squashtest.tm.service.internal.display.grid.filters.collector.FilterRequirementSearchCollector;
import org.squashtest.tm.service.internal.repository.display.utils.RequestAliasesConstants;

public class TestCaseThroughRequirementGrid extends AbstractGrid {

    private final Map<EntityType, List<Long>> entityReferenceFromScope;

    public TestCaseThroughRequirementGrid(Map<EntityType, List<Long>> entityReferenceFromScope) {
        this.entityReferenceFromScope = entityReferenceFromScope;
    }

    @Override
    protected Field<?> getIdentifier() {
        return TEST_CASE.TCLN_ID.as("ID");
    }

    @Override
    protected Field<?> getProjectIdentifier() {
        return TEST_CASE_LIBRARY_NODE.PROJECT_ID;
    }

    @Override
    protected List<GridColumn> getColumns() {
        // Only use for this.craftVariableFilters(request)
        // The AliasField is only used to set the key of aliasToFieldDictionary
        // Equivalent of GetField() is generated by getFieldTestCaseSearchSorts(request)
        return List.of(
                new GridColumn(
                        REQUIREMENT_VERSION.RES_ID.as(RequestAliasesConstants.ID), REQUIREMENT_VERSION.RES_ID),
                new GridColumn(
                        REQUIREMENT_VERSION.REQUIREMENT_ID.as(RequestAliasesConstants.ID_LIST),
                        REQUIREMENT_VERSION.REQUIREMENT_ID),
                new GridColumn(REQUIREMENT_VERSION.REFERENCE),
                new GridColumn(RESOURCE.NAME),
                new GridColumn(RESOURCE.DESCRIPTION),
                new GridColumn(RESOURCE.CREATED_ON),
                new GridColumn(RESOURCE.CREATED_BY),
                new GridColumn(
                        RESOURCE.LAST_MODIFIED_ON.as(RequestAliasesConstants.MODIFIED_ON),
                        RESOURCE.LAST_MODIFIED_ON),
                new GridColumn(
                        RESOURCE.LAST_MODIFIED_BY.as(RequestAliasesConstants.MODIFIED_BY),
                        RESOURCE.LAST_MODIFIED_BY),
                new GridColumn(REQUIREMENT_VERSION.CRITICALITY),
                new GridColumn(REQUIREMENT_VERSION.CATEGORY),
                new GridColumn(
                        REQUIREMENT_VERSION.REQUIREMENT_STATUS.as(RequestAliasesConstants.STATUS),
                        REQUIREMENT_VERSION.REQUIREMENT_STATUS),
                new GridColumn(
                        HIGH_LEVEL_REQUIREMENT.RLN_ID.as(RequestAliasesConstants.HIGH_LEVEL_REQUIREMENT_ID),
                        HIGH_LEVEL_REQUIREMENT.RLN_ID),
                // Get MILESTONE.MILESTONE_ID from GridRequest with GridFilterValue.id = MILESTONE_LABEL
                new GridColumn(
                        MILESTONE.MILESTONE_ID.as(RequestAliasesConstants.MILESTONE_LABEL),
                        MILESTONE.MILESTONE_ID),
                new GridColumn(
                        MILESTONE.STATUS.as(RequestAliasesConstants.MILESTONE_STATUS), MILESTONE.STATUS),
                new GridColumn(
                        MILESTONE.END_DATE.as(RequestAliasesConstants.MILESTONE_END_DATE), MILESTONE.END_DATE));
    }

    @Override
    protected Table<?> getTable() {
        return DSL.select(
                        REQUIREMENT_VERSION_COVERAGE.VERIFYING_TEST_CASE_ID,
                        REQUIREMENT_VERSION_COVERAGE.VERIFIED_REQ_VERSION_ID)
                .from(REQUIREMENT_VERSION_COVERAGE)
                .union(
                        DSL.select(TEST_CASE.TCLN_ID, REQUIREMENT_VERSION_COVERAGE.VERIFIED_REQ_VERSION_ID)
                                .from(REQUIREMENT_VERSION_COVERAGE)
                                .join(CALL_TEST_STEP)
                                .on(
                                        CALL_TEST_STEP.CALLED_TEST_CASE_ID.eq(
                                                REQUIREMENT_VERSION_COVERAGE.VERIFYING_TEST_CASE_ID))
                                .join(TEST_CASE_STEPS)
                                .on(CALL_TEST_STEP.TEST_STEP_ID.eq(TEST_CASE_STEPS.STEP_ID))
                                .join(TEST_CASE)
                                .on(TEST_CASE_STEPS.TEST_CASE_ID.eq(TEST_CASE.TCLN_ID)))
                .asTable();
    }

    @Override
    protected SelectSeekStepN<?> createQuery(GridRequest request, DSLContext dslContext) {
        List<FieldTestCaseSearchSort<?>> fieldTestCaseSearchSorts =
                getFieldTestCaseSearchSorts(request);
        List<? extends Field<?>> selectFields =
                fieldTestCaseSearchSorts.stream().map(FieldTestCaseSearchSort::getAliasField).toList();
        List<? extends SortField<?>> sortFields =
                fieldTestCaseSearchSorts.stream().map(FieldTestCaseSearchSort::getSortField).toList();
        // Only one field is used: TEST_CASE.TCLN_ID to get List<Long> with size = gridRequest.getSize()
        // The other fields are used to order the result
        return dslContext
                .select(selectFields)
                .from(getTable())
                .join(TEST_CASE)
                .on(
                        TEST_CASE.TCLN_ID.eq(
                                getTable().field(REQUIREMENT_VERSION_COVERAGE.VERIFYING_TEST_CASE_ID)))
                .join(TEST_CASE_LIBRARY_NODE)
                .on(TEST_CASE.TCLN_ID.eq(TEST_CASE_LIBRARY_NODE.TCLN_ID))
                .join(REQUIREMENT_VERSION)
                .on(
                        REQUIREMENT_VERSION.RES_ID.eq(
                                getTable().field(REQUIREMENT_VERSION_COVERAGE.VERIFIED_REQ_VERSION_ID)))
                .join(REQUIREMENT_LIBRARY_NODE)
                .on(REQUIREMENT_VERSION.REQUIREMENT_ID.eq(REQUIREMENT_LIBRARY_NODE.RLN_ID))
                .join(PROJECT)
                .on(REQUIREMENT_LIBRARY_NODE.PROJECT_ID.eq(PROJECT.PROJECT_ID))
                .join(RESOURCE)
                .on(REQUIREMENT_VERSION.RES_ID.eq(RESOURCE.RES_ID))
                .join(REQUIREMENT)
                .on(REQUIREMENT_VERSION.REQUIREMENT_ID.eq(REQUIREMENT.RLN_ID))
                .leftJoin(HIGH_LEVEL_REQUIREMENT)
                .on(REQUIREMENT.RLN_ID.eq(HIGH_LEVEL_REQUIREMENT.RLN_ID))
                .leftJoin(SCRIPTED_TEST_CASE)
                .on(SCRIPTED_TEST_CASE.TCLN_ID.eq(TEST_CASE.TCLN_ID))
                .leftJoin(KEYWORD_TEST_CASE)
                .on(KEYWORD_TEST_CASE.TCLN_ID.eq(TEST_CASE.TCLN_ID))
                .leftJoin(EXPLORATORY_TEST_CASE)
                .on(EXPLORATORY_TEST_CASE.TCLN_ID.eq(TEST_CASE.TCLN_ID))
                .leftJoin(AUTOMATION_REQUEST)
                .on(AUTOMATION_REQUEST.AUTOMATION_REQUEST_ID.eq(TEST_CASE.AUTOMATION_REQUEST_ID))
                .leftJoin(AUTOMATED_TEST)
                .on(AUTOMATED_TEST.TEST_ID.eq(TEST_CASE.TA_TEST))
                .leftJoin(AUTOMATED_TEST_TECHNOLOGY)
                .on(TEST_CASE.AUTOMATED_TEST_TECHNOLOGY.eq(AUTOMATED_TEST_TECHNOLOGY.AT_TECHNOLOGY_ID))
                .leftJoin(MILESTONE_REQ_VERSION)
                .on(MILESTONE_REQ_VERSION.REQ_VERSION_ID.eq(REQUIREMENT_VERSION.RES_ID))
                .leftJoin(MILESTONE)
                .on(MILESTONE.MILESTONE_ID.eq(MILESTONE_REQ_VERSION.MILESTONE_ID))
                .where(this.craftInvariantFilter())
                .and(this.craftVariableFilters(request))
                .groupBy(
                        TEST_CASE_LIBRARY_NODE.TCLN_ID,
                        TEST_CASE.TCLN_ID,
                        PROJECT.PROJECT_ID,
                        AUTOMATION_REQUEST.AUTOMATION_PRIORITY,
                        AUTOMATION_REQUEST.TRANSMITTED_ON,
                        AUTOMATION_REQUEST.REQUEST_STATUS,
                        SCRIPTED_TEST_CASE.TCLN_ID,
                        KEYWORD_TEST_CASE.TCLN_ID,
                        EXPLORATORY_TEST_CASE.TCLN_ID,
                        SCRIPTED_TEST_CASE.SCRIPT,
                        AUTOMATED_TEST_TECHNOLOGY.NAME,
                        AUTOMATED_TEST.TEST_ID)
                .orderBy(sortFields);
    }

    private List<FieldTestCaseSearchSort<?>> getFieldTestCaseSearchSorts(GridRequest request) {
        List<FieldTestCaseSearchSort<?>> fieldTestCaseSearchSorts =
                request.getSort().stream()
                        .map(FieldTestCaseSearchSort::getTestCaseSelectSearch)
                        .collect(Collectors.toList()); // need to be mutable
        addMissingField(fieldTestCaseSearchSorts, getIdentifier()); // Mandatory for getRows()
        addMissingField(fieldTestCaseSearchSorts, getProjectIdentifier()); // Mandatory for getRows()
        return fieldTestCaseSearchSorts;
    }

    private void addMissingField(List<FieldTestCaseSearchSort<?>> fieldSorts, Field<?> field) {
        if (field != null) {
            boolean containsField =
                    fieldSorts.stream().anyMatch(fieldSort -> fieldSort.getAliasField().equals(field));
            if (!containsField) {
                fieldSorts.add(new FieldTestCaseSearchSort<>(field, GridSort.SortDirection.ASC));
            }
        }
    }

    @Override
    protected Condition craftInvariantFilter() {
        Map<Field<Long>, List<Long>> groupedIds =
                this.entityReferenceFromScope.entrySet().stream()
                        .collect(
                                Collectors.groupingBy(
                                        entry -> convertToField(entry.getKey()),
                                        Collectors.flatMapping(
                                                entry -> entry.getValue().stream(), Collectors.toList())));

        return groupedIds.entrySet().stream()
                .map(entry -> entry.getKey().in(entry.getValue()))
                .reduce(DSL.noCondition(), Condition::or);
    }

    private Field<Long> convertToField(EntityType entityType) {
        return switch (entityType) {
            case REQUIREMENT_LIBRARY -> PROJECT.RL_ID;
            case REQUIREMENT, HIGH_LEVEL_REQUIREMENT, REQUIREMENT_FOLDER ->
                    REQUIREMENT_LIBRARY_NODE.RLN_ID;
            default -> throw new IllegalArgumentException("Unsupported entity type: " + entityType);
        };
    }

    @Override
    protected Long countRows(DSLContext dslContext, GridRequest request) {
        return createQuery(request, dslContext).fetchStream().count();
    }

    @Override
    protected Condition craftVariableFilters(GridRequest request) {
        if (request.getFilterValues().isEmpty()) {
            return DSL.noCondition();
        } else {
            return request.getFilterValues().stream()
                    .collect(
                            new FilterRequirementSearchCollector(
                                    this.aliasToFieldDictionary, request.isSearchOnMultiColumns()));
        }
    }
}
